/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 187 by dpavlin, Tue Mar 16 21:36:45 2010 UTC revision 234 by dpavlin, Sat Jan 22 16:07:46 2011 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47  }  }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //' ) | \
52            sed -e 's/ *//g' -e 's/\/.*$//'
53    }
54    
55  lxc_status() {  lxc_status() {
56          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
57                  on_boot="       "                  boot="-"
58                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
59                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
60          done          done ) | column -t
61  }  }
62    
63    
# Line 50  cleanup_init_scripts() { Line 65  cleanup_init_scripts() {
65          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
66    
67          ls \          ls \
68                    $rootfs/etc/rc?.d/*checkroot* \
69                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
70                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
71                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
72                    $rootfs/etc/rc?.d/*udev* \
73          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
74    
75            echo $1 > $rootfs/etc/hostname
76            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
77  }  }
78    
79    
# Line 64  setup_inittab() { Line 84  setup_inittab() {
84    
85          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
86          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
87          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
88                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
89                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
90                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 73  setup_inittab() { Line 93  setup_inittab() {
93  }  }
94    
95    
96    lxc_log() {
97            echo `date +%Y-%m-%dT%H:%M:%S` $*
98    }
99    
100    
101  lxc_kill() {  lxc_kill() {
102          name=$1          name=$1
103          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 107  lxc_kill() {
107                  lxc-info -n $name                  lxc-info -n $name
108                  exit 1                  exit 1
109          fi          fi
110          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
111          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
112  }  }
113    
114  lxc_stop() {  lxc_stop() {
115            lxc_log "$name stop"
116          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
117          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
118            lxc_log "$name stoped"
119  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
120  }  }
121    
122    
123  lxc_start() {  lxc_start() {
124          name=$1          name=$1
125            rootfs=$(lxc_rootfs $1)
126    
127            if [ ! -e $rootfs ] ; then
128                    echo "ERROR $name rootfs $rootfs not found"
129                    return
130            fi
131    
132          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
133                  echo "$name start"                  lxc_log "$name start"
134                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
135                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
136                  lxc-info  -n $name                  lxc-info  -n $name
# Line 105  lxc_start() { Line 138  lxc_start() {
138          fi          fi
139  }  }
140    
 lxc_log() {  
         echo `date +%Y-%m-%dT%H:%M:%S` $*  
 }  
   
141  lxc_watchdog() {  lxc_watchdog() {
142  name=$1  name=$1
143  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
# Line 152  while true; do Line 181  while true; do
181          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
182  done  done
183    
184  lxc_log "$name exited"  lxc_log "$name watchdog exited"
185    
186  }  }
187    
188    
189    usage() {
190            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
191            exit 3
192    }
193    
194  command_on_lxc() {  command_on_lxc() {
195  command=$1  command=$1
196  shift  shift
# Line 168  case "$command" in Line 202  case "$command" in
202  start)  start)
203          lxc_exists $1          lxc_exists $1
204          cleanup_init_scripts $1          cleanup_init_scripts $1
205          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
206          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
207            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
208          lxc_start $1          lxc_start $1
209          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
210          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 184  reload|force-reload|restart|reboot) Line 219  reload|force-reload|restart|reboot)
219  watchdog)  watchdog)
220          lxc_watchdog $1          lxc_watchdog $1
221          ;;          ;;
222    boot)
223            echo $1 > /var/lib/lxc/$1/on_boot
224            ;;
225    disable)
226            echo -n > /var/lib/lxc/$1/on_boot
227            ;;
228  *)  *)
229          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
230          ;;          ;;
231    
232  esac  esac
# Line 194  esac Line 234  esac
234  }  }
235    
236  command=$1  command=$1
237  shift  test -z "$command" && usage
   
238  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
239    shift
240    
241  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
242          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
243                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
244                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
245                            command_on_lxc $command $name
246                    else
247                            echo "# skip $command $name"
248                    fi
249          done          done
250  else  else
251          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.187  
changed lines
  Added in v.234

  ViewVC Help
Powered by ViewVC 1.1.26